---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "backendburgers.fullname" . }}
  labels:
    {{- include "backendburgers.labels" . | nindent 4 }}
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "backendburgers.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "backendburgers.selectorLabels" . | nindent 8 }}
    spec:
      enableServiceLinks: false
      automountServiceAccountToken: false
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ coalesce .Values.image.tag .Values.global.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: "{{ coalesce .Values.image.pullPolicy .Values.global.image.pullPolicy }}"
          ports:
            - name: http
              containerPort: 8080
              protocol: TCP
          startupProbe:
            httpGet:
              path: /.well-known/apollo/server-health
              port: http
            periodSeconds: 10
            failureThreshold: 60
          livenessProbe:
            httpGet:
              path: /.well-known/apollo/server-health
              port: http
            periodSeconds: 10
          readinessProbe:
            httpGet:
              path: /.well-known/apollo/server-health
              port: http
            periodSeconds: 10
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          volumeMounts:
            - mountPath: /.npm/_cacache
              name: npm-cacache
            - mountPath: /.npm/_logs
              name: npm-logs
            - mountPath: /tmp
              name: tmp
          env:
            {{- with .Values.global }}
            {{- if .banktransactieservice.enabled }}
            - name: BANKTRANSACTIESERVICE_URL
              value: {{ printf "http://%s-%s" $.Release.Name "banktransactieservice" | quote }}
            {{- end }}{{- if .huishoudboekjeservice.enabled }}
            - name: HUISHOUDBOEKJESERVICE_URL
              value: {{ printf "http://%s-%s" $.Release.Name "huishoudboekje" | quote }}
            {{- end }}{{- if .organisatieservice.enabled }}
            - name: ORGANISATIESERVICE_URL
              value: {{ printf "http://%s-%s" $.Release.Name "organisatieservice" | quote }}
            {{- end }}{{- end }}
            - name: LOG_LEVEL
              value: {{ coalesce .Values.log_level .Values.global.log_level | upper | quote }}
            {{- if .Values.extraEnvVars }}{{- toYaml .Values.extraEnvVars | nindent 12 }}{{- end }}
      volumes:
        - name: npm-cacache
          emptyDir: {}
        - name: npm-logs
          emptyDir: {}
        - name: tmp
          emptyDir: {}
